<script>
import { mapState } from 'vuex';
import { SocketState } from 'colibri-sockets';

import * as helperColors from '~/helpers/colors.js';

export default {
  name: `websockets-dropdown`,
  computed: {
    ...mapState({
      websockets: (state) => state.websockets.websockets,
    }),
  },
  methods: {
    isDown(idx) {
      return this.websockets[idx].state === SocketState.DISCONNECTED
          || this.websockets[idx].state === SocketState.CLOSED;
    },
    stateColor (idx) {
      return helperColors.WEBSOCKET_STATE_COLORS[this.websockets[idx].state]
          || helperColors.WEBSOCKET_STATE_COLORS.default;
    },
    async toggleConnection(idx) {
      if (this.isDown(idx)) {
        await this.$store.dispatch(`websockets/connectWebsocket`, { name: this.websockets[idx].name });
      } else {
        await this.$store.dispatch(`websockets/disconnectWebsocket`, { name: this.websockets[idx].name });
      }
    },
  },
  async mounted() {
    if (this.$store.state.websockets.websockets === null) {
      await this.$store.dispatch(`websockets/loadWebsockets`, { $axios: this.$axios });
    }
  },
}
</script>

<template>
  <v-menu offset-y :nudge-bottom="4">
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        fab
        small
        :elevation="6"
        v-bind="attrs"
        v-on="on"
      >
        <v-icon>mdi-flash</v-icon>
      </v-btn>
    </template>
    <v-list dense class="text-xs">
      <v-list-item-group>
        <v-list-item
          v-for="(websocket, idx) in websockets"
          :key="idx"
          @click.stop="() => toggleConnection(idx)"
        >
          <v-list-item-icon>
            <v-badge inline :color="stateColor(idx)" />
          </v-list-item-icon>
          <v-list-item-title>
            <span>{{ websocket.host }}:{{ websocket.port }}</span>
          </v-list-item-title>
        </v-list-item>
      </v-list-item-group>
    </v-list>
  </v-menu>
</template>
